#include "user_task.h"
#include "cmd.h"

#ifdef DEBUG

CMD_t cmd;
CMD_NUC_t Nuc;
CMD_RC_t rc_ctrl;

#else

static CMD_t cmd;
static CMD_NUC_t Nuc;	
static CMD_RC_t rc_ctrl;

#endif 




void Task_cmd(void *argument){
   (void)argument; /*未使用传递参数 消除警告*/

 /* 计算到下一次调度任务所需要的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / TASK_FREQ_CTRL_CMD;
    /**/
	
  uint32_t tick = osKernelGetTickCount(); /*控制任务运行频率的计时 */
   while(1){
#ifdef DEBUG
    /*记录任务所需要的栈空间*/
    task_runtime.stack_water_mark.cmd =
        osThreadGetStackSpace(osThreadGetId());	 
#endif

    osKernelLock(); /*锁住RTOS内核调度*/

    /*将各任务接收到的原始数据解析为通用的控制命令*/
		 
	 if(osMessageQueueGet(task_runtime.msgq.cmd.raw.rc, &rc_ctrl, 0, 0) == osOK)//遥控器
    CMD_ParseRC(&cmd, &rc_ctrl);
		 
		if(osMessageQueueGet(task_runtime.msgq.cmd.raw.nuc, &Nuc,0 ,0) ==osOK) //nuc
      CMD_ParseNuc(&cmd,&Nuc);
				
    osKernelUnlock(); /* 同上 解锁RTOS内核 */	
		
		     osMessageQueueReset(task_runtime.msgq.cmd.up_ctrl);
		
     osMessageQueuePut(task_runtime.msgq.cmd.up_ctrl,&cmd,0,0);

    tick += delay_tick; /*计算下一个唤醒时刻*/
    osDelayUntil(tick); /*绝对延时 等待下一个唤醒时刻 */


}
		
}



